Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH10h_HReady.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH10h_HReady.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH10h_HReady.asm	(revision 150)
@@ -12,6 +12,6 @@
 ;		DL:		Translated Drive number
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
-;		SS:BP:	Ptr to INTPACK
-;	Returns with INTPACK in SS:BP:
+;		SS:BP:	Ptr to IDEREGS_AND_INTPACK
+;	Returns with INTPACK:
 ;		AH:		Int 13h return status
 ;		CF:		0 if succesfull, 1 if error
@@ -19,5 +19,9 @@
 ALIGN JUMP_ALIGN
 AH10h_HandlerForCheckDriveReady:
-	call	HStatus_WaitRdyDefTime
-	xor		ah, ah
+%ifdef USE_186
+	push	Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
+	jmp		Device_SelectDrive
+%else
+	call	Device_SelectDrive
 	jmp		Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
+%endif
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH11h_HRecal.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH11h_HRecal.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH11h_HRecal.asm	(revision 150)
@@ -12,6 +12,6 @@
 ;		DL:		Translated Drive number
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
-;		SS:BP:	Ptr to INTPACK
-;	Returns with INTPACK in SS:BP:
+;		SS:BP:	Ptr to IDEREGS_AND_INTPACK
+;	Returns with INTPACK:
 ;		AH:		BIOS Error code
 ;		CF:		0 if succesfull, 1 if error
@@ -32,4 +32,5 @@
 ;	Parameters:
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to IDEREGS_AND_INTPACK
 ;	Returns:
 ;		AH:		BIOS Error code
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH15h_HSize.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH15h_HSize.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH15h_HSize.asm	(revision 150)
@@ -12,6 +12,6 @@
 ;		DL:		Translated Drive number
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
-;		SS:BP:	Ptr to INTPACK
-;	Returns with INTPACK in SS:BP:
+;		SS:BP:	Ptr to IDEPACK
+;	Returns with INTPACK:
 ;		If succesfull:
 ;			AH:		3 (Hard disk accessible)
@@ -25,10 +25,45 @@
 ALIGN JUMP_ALIGN
 AH15h_HandlerForReadDiskDriveSize:
-	call	HCapacity_GetSectorCountFromOurAH08h		; Sector count to DX:AX
-	mov		[bp+INTPACK.cx], dx							; HIWORD to CX
-	mov		[bp+INTPACK.dx], ax							; LOWORD to DX
+	call	AH15h_GetSectorCountToDXAX
+	mov		[bp+IDEPACK.intpack+INTPACK.cx], dx			; HIWORD to CX
+	mov		[bp+IDEPACK.intpack+INTPACK.dx], ax			; LOWORD to DX
 
 	xor		ah, ah
-	call	HError_SetErrorCodeToIntpackInSSBPfromAH	; Store success to BDA and CF
-	mov		BYTE [bp+INTPACK.ah], 3						; Type code = Hard disk
+	call	Int13h_SetErrorCodeToIntpackInSSBPfromAH	; Store success to BDA and CF
+	mov		BYTE [bp+IDEPACK.intpack+INTPACK.ah], 3		; Type code = Hard disk
 	jmp		Int13h_ReturnFromHandlerWithoutStoringErrorCode
+
+
+;--------------------------------------------------------------------
+; AH15h_GetSectorCountFromForeignDriveToDXAX:
+; AH15h_GetSectorCountToDXAX:
+;	Parameters:
+;		DL:		Drive number
+;		DS:		RAMVARS segment
+;		DS:DI:	Ptr to DPT (AH15h_GetSectorCount only)
+;	Returns:
+;		DX:AX:	Total sector count
+;		BX:		Zero
+;	Corrupts registers:
+;		CX
+;--------------------------------------------------------------------
+AH15h_GetSectorCountFromForeignDriveToDXAX:
+	mov		ah, GET_DRIVE_PARAMETERS
+	call	Int13h_CallPreviousInt13hHandler
+	jmp		SHORT ConvertAH08hReturnValuesToSectorCount
+
+ALIGN JUMP_ALIGN
+AH15h_GetSectorCountToDXAX:
+	call	AH8h_GetDriveParameters
+	; Fall to ConvertAH08hReturnValuesToSectorCount
+
+ConvertAH08hReturnValuesToSectorCount:
+	call	HAddress_ExtractLCHSparametersFromOldInt13hAddress
+	xor		ax, ax			; Zero AX
+	inc		cx				; Max cylinder number to cylinder count
+	xchg	al, bh			; AX=Max head number, BX=Sectors per track
+	inc		ax				; AX=Head count
+	mul		bx				; AX=Head count * Sectors per track
+	mul		cx				; DX:AX = Total sector count
+	xor		bx, bx			; Zero BX for 48-bit sector count (and clear CF)
+	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH1h_HStatus.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH1h_HStatus.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH1h_HStatus.asm	(revision 150)
@@ -12,6 +12,6 @@
 ;		DL:		Translated Drive number
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
-;		SS:BP:	Ptr to INTPACK
-;	Returns with INTPACK in SS:BP:
+;		SS:BP:	Ptr to IDEREGS_AND_INTPACK
+;	Returns with INTPACK:
 ;		AH:		Int 13h floppy return status
 ;		CF:		0 if AH = RET_HD_SUCCESS, 1 otherwise (error)
@@ -21,4 +21,4 @@
 	LOAD_BDA_SEGMENT_TO	ds, ax, !
 	xchg	ah, [BDA.bHDLastSt]		; Load and clear last error
-	call	HError_SetErrorCodeToIntpackInSSBPfromAH
+	call	Int13h_SetErrorCodeToIntpackInSSBPfromAH
 	jmp		Int13h_ReturnFromHandlerWithoutStoringErrorCode
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH23h_HFeatures.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH23h_HFeatures.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH23h_HFeatures.asm	(revision 150)
@@ -14,13 +14,13 @@
 ;		DL:		Translated Drive number
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
-;		SS:BP:	Ptr to INTPACK
-;	Parameters on INTPACK in SS:BP:
+;		SS:BP:	Ptr to IDEPACK
+;	Parameters on INTPACK:
 ;		AL:		Feature Number (parameter to Features Register = subcommand)
-;	(Parameter registers are undocumented, there are specific for this BIOS):
-;		BH:		Parameter to Sector Count Register (subcommand specific)
-;		BL:		Parameter to Sector Number Register (subcommand specific)
-;		CL:		Parameter to Low Cylinder Register (subcommand specific)
-;		CH:		Parameter to High Cylinder Register (subcommand specific)
-;	Returns with INTPACK in SS:BP:
+;	(Parameter registers are undocumented, these are specific for this BIOS):
+;		BL:		Parameter to Sector Count Register (subcommand specific)
+;		BH:		Parameter to LBA Low / Sector Number Register (subcommand specific)
+;		CL:		Parameter to LBA Middle / Cylinder Low Register (subcommand specific)
+;		CH:		Parameter to LBA High / Cylinder High Register (subcommand specific)
+;	Returns with INTPACK:
 ;		AH:		Int 13h return status
 ;		CF:		0 if succesfull, 1 if error
@@ -28,4 +28,6 @@
 ALIGN JUMP_ALIGN
 AH23h_HandlerForSetControllerFeatures:
+	xchg	si, ax		; SI = Feature Number
+	mov		dx, [bp+IDEPACK.intpack+INTPACK.bx]
 %ifndef USE_186
 	call	AH23h_SetControllerFeatures
@@ -40,44 +42,20 @@
 ; AH23h_SetControllerFeatures
 ;	Parameters:
-;		AL:		Feature Number (parameter to Features Register = subcommand)
-;		BH:		Parameter to Sector Count Register (subcommand specific)
-;		BL:		Parameter to Sector Number Register (subcommand specific)
-;		CL:		Parameter to Low Cylinder Register (subcommand specific)
-;		CH:		Parameter to High Cylinder Register (subcommand specific)
+;		DL:		Parameter to Sector Count Register (subcommand specific)
+;		DH:		Parameter to LBA Low / Sector Number Register (subcommand specific)
+;		CL:		Parameter to LBA Middle / Cylinder Low Register (subcommand specific)
+;		CH:		Parameter to LBA High / Cylinder High Register (subcommand specific)
+;		SI:		Feature Number (parameter to Features Register = subcommand)
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to IDEPACK
 ;	Returns:
 ;		AH:		Int 13h return status
 ;		CF:		0 if succesfull, 1 if error
 ;	Corrupts registers:
-;		AX, BX, CX, DX, SI
+;		AL, BX, CX, DX
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 AH23h_SetControllerFeatures:
-	; Backup AL and BH to SI
-	mov		ah, bh
-	xchg	si, ax
-
-	; Select Master or Slave and wait until ready
-	call	HDrvSel_SelectDriveAndDisableIRQ
-	jc		SHORT .ReturnWithErrorCodeInAH
-
-	; Output Feature Number
-	mov		ax, si						; Feature number to AL
-	mov		dx, [RAMVARS.wIdeBase]		; Load base port address
-	inc		dx							; REGW_IDE_FEAT
-	out		dx, al
-
-	; Output parameters to Sector Number Register and Cylinder Registers
-	xor		bh, bh						; Zero head number
-	dec		dx							; Back to base port address
-	call	HCommand_OutputTranslatedLCHSaddress
-
-	; Output parameter to Sector Count Register and command
-	xchg	ax, si						; Sector Count Reg param to AH
-	mov		al, ah						; Sector Count Reg param to AL
-	mov		ah, HCMD_SET_FEAT			; Load Set Features command to AH
-	call	HCommand_OutputSectorCountAndCommand
-
-	jmp		HStatus_WaitBsyDefTime		; Wait until drive ready
-.ReturnWithErrorCodeInAH:
-	ret
+	mov		al, COMMAND_SET_FEATURES
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_BSY, FLG_STATUS_BSY)
+	jmp		Idepack_StoreNonExtParametersAndIssueCommandFromAL
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH24h_HSetBlocks.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH24h_HSetBlocks.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH24h_HSetBlocks.asm	(revision 150)
@@ -13,8 +13,8 @@
 ;		DL:		Translated Drive number
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
-;		SS:BP:	Ptr to INTPACK
-;	Parameters on INTPACK in SS:BP:
+;		SS:BP:	Ptr to IDEPACK
+;	Parameters on INTPACK:
 ;		AL:		Number of Sectors per Block (1, 2, 4, 8, 16, 32, 64 or 128)
-;	Returns with INTPACK in SS:BP:
+;	Returns with INTPACK:
 ;		AH:		Int 13h return status
 ;		CF:		0 if succesfull, 1 if error
@@ -22,4 +22,12 @@
 ALIGN JUMP_ALIGN
 AH24h_HandlerForSetMultipleBlocks:
+	test	WORD [di+DPT.wFlags], FLG_DPT_BLOCK_MODE_SUPPORTED
+	jnz		SHORT .TryToSetBlockMode
+	stc
+	mov		ah, RET_HD_INVALID
+	jmp		Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
+
+ALIGN JUMP_ALIGN
+.TryToSetBlockMode:
 %ifndef USE_186
 	call	AH24h_SetBlockSize
@@ -32,10 +40,9 @@
 
 ;--------------------------------------------------------------------
-; Sets block size for block mode transfers.
-;
 ; AH24h_SetBlockSize
 ;	Parameters:
 ;		AL:		Number of Sectors per Block (1, 2, 4, 8, 16, 32, 64 or 128)
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to IDEPACK
 ;	Returns:
 ;		AH:		Int 13h return status
@@ -46,24 +53,17 @@
 ALIGN JUMP_ALIGN
 AH24h_SetBlockSize:
-	; Select Master or Slave and wait until ready
-	mov		bl, al								; Backup block size
-	call	HDrvSel_SelectDriveAndDisableIRQ	; Select drive and wait until ready
-	jc		SHORT .ReturnWithErrorCodeInAH		; Return if error
-
-	; Output block size and command
-	mov		al, bl								; Restore block size to AL
-	mov		ah, HCMD_SET_MUL					; Load command to AH
-	mov		dx, [RAMVARS.wIdeBase]				; Load base port address
-	add		dx, BYTE REG_IDE_CNT
-	call	HCommand_OutputSectorCountAndCommand
-	call	HStatus_WaitBsyDefTime				; Wait until drive not busy
+	MIN_U	al, MAX_SUPPORTED_BLOCK_SIZE_IN_SECTORS
+	push	ax
+	xchg	dx, ax			; DL = Block size (Sector Count Register)
+	mov		al, COMMAND_SET_MULTIPLE_MODE
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_DRDY, FLG_STATUS_DRDY)
+	call	Idepack_StoreNonExtParametersAndIssueCommandFromAL
+	pop		bx
 	jc		SHORT .DisableBlockMode
 
 	; Store new block size to DPT and return
-	mov		[di+DPT.bSetBlock], bl				; Store new block size
-	xor		ah, ah								; Zero AH and CF since success
+	mov		[di+DPT_ATA.bSetBlock], bl				; Store new block size
 	ret
 .DisableBlockMode:
-	mov		BYTE [di+DPT.bSetBlock], 1			; Disable block mode
-.ReturnWithErrorCodeInAH:
+	mov		BYTE [di+DPT_ATA.bSetBlock], 1			; Disable block mode
 	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH25h_HDrvID.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH25h_HDrvID.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH25h_HDrvID.asm	(revision 150)
@@ -13,8 +13,8 @@
 ;		DL:		Translated Drive number
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
-;		SS:BP:	Ptr to INTPACK
-;	Parameters on INTPACK in SS:BP:
+;		SS:BP:	Ptr to IDEPACK
+;	Parameters on INTPACK:
 ;		ES:BX:	Ptr to buffer to receive 512-byte drive information
-;	Returns with INTPACK in SS:BP:
+;	Returns with INTPACK:
 ;		AH:		Int 13h return status
 ;		CF:		0 if succesfull, 1 if error
@@ -22,77 +22,13 @@
 ALIGN JUMP_ALIGN
 AH25h_HandlerForGetDriveInformation:
-	; Wait until previously selected drive is ready
-	call	HDrvSel_SelectDriveAndDisableIRQ
-	jc		SHORT .ReturnWithErrorCodeInAH		; Return if error
+	push	bp
 
-	; Get drive information
-	mov		bx, [bp+INTPACK.bx]
-	call	HPIO_NormalizeDataPointer
-	push	bx
-	mov		dx, [RAMVARS.wIdeBase]		; Load base port address
-	eMOVZX	bx, BYTE [di+DPT.bIdeOff]	; Load offset to IDEVARS
-	mov		bl, [cs:bx+IDEVARS.bBusType]; Load bus type to BL
-	mov		bh, [di+DPT.bDrvSel]		; Load drive sel byte to BH
-	pop		di							; Pop buffer offset to DI
-	call	AH25h_GetDriveInfo			; Get drive information
-.ReturnWithErrorCodeInAH:
+	mov		si, [bp+IDEPACK.intpack+INTPACK.bx]
+	call	AccessDPT_GetDriveSelectByteToAL
+	mov		bh, al
+	eMOVZX	ax, BYTE [di+DPT.bIdevarsOffset]
+	xchg	bp, ax
+	call	Device_IdentifyToBufferInESSIwithDriveSelectByteInBH
+
+	pop		bp
 	jmp		Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
-
-
-;--------------------------------------------------------------------
-; Gets drive information using Identify Device command.
-;
-; AH25h_GetDriveInfo
-;	Parameters:
-;		BH:		Drive Select byte for Drive and Head Select Register
-;		BL:		Bus type
-;		DX:		IDE Controller base port address
-;		DS:		Segment to RAMVARS
-;		ES:DI:	Ptr to buffer to receive 512 byte drive information
-;	Returns:
-;		AH:		Int 13h return status (will be stored to BDA)
-;		CF:		0 if succesfull, 1 if error
-;	Corrupts registers:
-;		AL, CX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-AH25h_GetDriveInfo:
-	push	di
-	push	dx
-	push	bx
-
-	; Select Master or Slave drive.
-	; DO NOT WAIT UNTIL CURRENTLY SELECTED IS READY!
-	; It makes slave drive detection impossible if master is not present.
-	mov		[RAMVARS.wIdeBase], dx		; Store IDE Base port to RAMVARS
-	add		dx, BYTE REG_IDE_DRVHD		; DX to Drive and Head Sel Register
-	mov		al, bh						; Drive Select byte to AL
-	out		dx, al						; Select Master or Slave drive
-	sub		dx, BYTE REG_IDE_DRVHD		; Back to IDE Base port
-
-	; Wait until ready to accept commands
-	xor		bh, bh						; BX now contains bus type
-	mov		cl, B_TIMEOUT_DRVINFO		; Load short timeout
-	cmp		[RAMVARS.bDrvCnt], bh		; Detecting first drive?
-	eCMOVE	cl, B_TIMEOUT_RESET			;  If so, load long timeout
-	call	HStatus_WaitRdy				; Wait until ready to accept commands
-	jc		SHORT .ReturnWithErrorCodeInAH
-
-	; Output command
-	mov		al, HCMD_ID_DEV				; Load Identify Device command to AL
-	out		dx, al						; Output command
-	call	HStatus_WaitDrqDefTime		; Wait until ready to transfer (no IRQ!)
-	jc		SHORT .ReturnWithErrorCodeInAH
-
-	; Transfer data
-	sub		dx, BYTE REGR_IDE_ST		; DX to IDE Data Reg
-	mov		cx, 256						; Transfer 256 words (single sector)
-	cld									; INSW to increment DI
-	call	[cs:bx+g_rgfnPioRead]		; Read ID sector
-	call	HStatus_WaitRdyDefTime		; Wait until drive ready
-
-.ReturnWithErrorCodeInAH:
-	pop		bx
-	pop		dx
-	pop		di
-	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH2h_HRead.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH2h_HRead.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH2h_HRead.asm	(revision 150)
@@ -13,7 +13,7 @@
 ;		DL:		Translated Drive number
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
-;		SS:BP:	Ptr to INTPACK
-;	Parameters on INTPACK in SS:BP:
-;		AL:		Number of sectors to read (1...255)
+;		SS:BP:	Ptr to IDEPACK
+;	Parameters on INTPACK:
+;		AL:		Number of sectors to read (1...255, 0=256)
 ;		CH:		Cylinder number, bits 7...0
 ;		CL:		Bits 7...6: Cylinder number bits 9 and 8
@@ -21,5 +21,5 @@
 ;		DH:		Starting head number (0...255)
 ;		ES:BX:	Pointer to buffer recieving data
-;	Returns with INTPACK in SS:BP:
+;	Returns with INTPACK:
 ;		AH:		Int 13h/40h floppy return status
 ;		AL:		Burst error length if AH returns 11h, undefined otherwise
@@ -28,22 +28,14 @@
 ALIGN JUMP_ALIGN
 AH2h_HandlerForReadDiskSectors:
-	test	al, al						; Invalid sector count?
-	jz		SHORT AH2h_ZeroCntErr		;  If so, return with error
-
-	; Select sector or block mode command
-	mov		ah, HCMD_READ_SECT			; Load sector mode command
-	cmp		BYTE [di+DPT.bSetBlock], 1	; Block mode enabled?
-	eCMOVA	ah, HCMD_READ_MUL			; Load block mode command
-
-	; Transfer data
-	call	HCommand_OutputCountAndLCHSandCommand
-	jc		SHORT .ReturnWithErrorCodeInAH
-	mov		bx, [bp+INTPACK.bx]
-	call	HPIO_ReadBlock				; Read data from IDE-controller
-.ReturnWithErrorCodeInAH:
+	mov		ah, COMMAND_READ_SECTORS	; Load sector mode command
+	test	WORD [di+DPT.wFlags], FLG_DPT_BLOCK_MODE_SUPPORTED
+	eCMOVNZ	ah, COMMAND_READ_MULTIPLE	; Load block mode command
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_DRQ, FLG_STATUS_DRQ)
+	mov		si, [bp+IDEPACK.intpack+INTPACK.bx]
+%ifdef USE_186
+	push	Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
+	jmp		Idepack_TranslateOldInt13hAddressAndIssueCommandFromAH
+%else
+	call	Idepack_TranslateOldInt13hAddressAndIssueCommandFromAH
 	jmp		Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
-
-; Invalid sector count (also for AH=3h and AH=4h)
-AH2h_ZeroCntErr:
-	mov		ah, RET_HD_INVALID			; Invalid value passed
-	jmp		Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
+%endif
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH3h_HWrite.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH3h_HWrite.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH3h_HWrite.asm	(revision 150)
@@ -13,6 +13,6 @@
 ;		DL:		Translated Drive number
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
-;		SS:BP:	Ptr to INTPACK
-;	Parameters on INTPACK in SS:BP:
+;		SS:BP:	Ptr to IDEREGS_AND_INTPACK
+;	Parameters on INTPACK:
 ;		AL:		Number of sectors to write
 ;		CH:		Cylinder number, bits 7...0
@@ -21,5 +21,5 @@
 ;		DH:		Starting head number (0...255)
 ;		ES:BX:	Pointer to source data
-;	Returns with INTPACK in SS:BP:
+;	Returns with INTPACK:
 ;		AH:		Int 13h/40h floppy return status
 ;		CF:		0 if successfull, 1 if error
@@ -27,17 +27,15 @@
 ALIGN JUMP_ALIGN
 AH3h_HandlerForWriteDiskSectors:
-	test	al, al						; Invalid sector count?
-	jz		SHORT AH2h_ZeroCntErr		;  If so, return with error
-
-	; Select sector or block mode command
-	mov		ah, HCMD_WRITE_SECT			; Load sector mode command
-	cmp		BYTE [di+DPT.bSetBlock], 1	; Block mode enabled?
-	eCMOVA	ah, HCMD_WRITE_MUL			; Load block mode command
-
-	; Transfer data
-	call	HCommand_OutputCountAndLCHSandCommand
-	jc		SHORT .ReturnWithErrorCodeInAH
-	mov		bx, [bp+INTPACK.bx]
-	call	HPIO_WriteBlock				; Write data to IDE-controller
-.ReturnWithErrorCodeInAH:
+	; Prepare parameters
+	mov		ah, COMMAND_WRITE_SECTORS	; Load sector mode command
+	test	WORD [di+DPT.wFlags], FLG_DPT_BLOCK_MODE_SUPPORTED
+	eCMOVNZ	ah, COMMAND_WRITE_MULTIPLE	; Load block mode command
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_DRQ, FLG_STATUS_DRQ)
+	mov		si, [bp+IDEPACK.intpack+INTPACK.bx]
+%ifdef USE_186
+	push	Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
+	jmp		Idepack_TranslateOldInt13hAddressAndIssueCommandFromAH
+%else
+	call	Idepack_TranslateOldInt13hAddressAndIssueCommandFromAH
 	jmp		Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
+%endif
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH4h_HVerify.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH4h_HVerify.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH4h_HVerify.asm	(revision 150)
@@ -26,12 +26,11 @@
 ALIGN JUMP_ALIGN
 AH4h_HandlerForVerifyDiskSectors:
-	test	al, al						; Invalid sector count?
-	jz		SHORT AH2h_ZeroCntErr		;  If so, return with error
-
-	mov		ah, HCMD_VERIFY_SECT		; Load command to AH
-	call	HCommand_OutputCountAndLCHSandCommand
-	jc		SHORT .ReturnWithErrorCodeInAH
-	mov		bx, di						; DS:BX now points to DPT
-	call	HStatus_WaitIrqOrRdy		; Wait for IRQ or RDY
-.ReturnWithErrorCodeInAH:
+	mov		ah, COMMAND_WRITE_SECTORS
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_DRQ, FLG_STATUS_DRDY)
+%ifdef USE_186
+	push	Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
+	jmp		Idepack_TranslateOldInt13hAddressAndIssueCommandFromAH
+%else
+	call	Idepack_TranslateOldInt13hAddressAndIssueCommandFromAH
 	jmp		Int13h_ReturnFromHandlerAfterStoringErrorCodeFromAH
+%endif
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH8h_HParams.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH8h_HParams.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH8h_HParams.asm	(revision 150)
@@ -12,6 +12,6 @@
 ;		DL:		Translated Drive number
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
-;		SS:BP:	Ptr to INTPACK
-;	Returns with INTPACK in SS:BP:
+;		SS:BP:	Ptr to IDEPACK
+;	Returns with INTPACK:
 ;		CH:		Maximum cylinder number, bits 7...0
 ;		CL:		Bits 7...6: Cylinder number bits 9...8
@@ -34,6 +34,6 @@
 	call	RamVars_GetCountOfKnownDrivesToDL
 .ReturnAfterStoringValuesToIntpack:
-	mov		[bp+INTPACK.cx], cx
-	mov		[bp+INTPACK.dx], dx
+	mov		[bp+IDEPACK.intpack+INTPACK.cx], cx
+	mov		[bp+IDEPACK.intpack+INTPACK.dx], dx
 	xor		ah, ah
 .ReturnErrorFromPreviousInt13hHandler:
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH9h_HInit.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH9h_HInit.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH9h_HInit.asm	(revision 150)
@@ -12,6 +12,6 @@
 ;		DL:		Translated Drive number
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
-;		SS:BP:	Ptr to INTPACK
-;	Returns with INTPACK in SS:BP:
+;		SS:BP:	Ptr to IDEPACK
+;	Returns with INTPACK:
 ;		AH:		Int 13h return status
 ;		CF:		0 if succesfull, 1 if error
@@ -34,4 +34,5 @@
 ;	Parameters:
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to IDEPACK
 ;	Returns:
 ;		AH:		Int 13h return status
@@ -45,26 +46,27 @@
 
 	; Try to select drive and wait until ready
-	or		BYTE [di+DPT.bReset], MASK_RESET_ALL		; Everything uninitialized
-	call	HDrvSel_SelectDriveAndDisableIRQ
+	or		WORD [di+DPT.wFlags], MASK_DPT_RESET		; Everything uninitialized
+	call	AccessDPT_GetDriveSelectByteToAL
+	mov		[bp+IDEPACK.bDrvAndHead], al
+	call	Device_SelectDrive
 	jc		SHORT .ReturnNotSuccessfull
-	and		BYTE [di+DPT.bReset], ~FLG_RESET_nDRDY		; Clear since success
+	and		WORD [di+DPT.wFlags], ~FLG_DPT_RESET_nDRDY	; Clear since success
 
 	; Initialize CHS parameters if LBA is not used
-	call	AH9h_InitializeDeviceParameters
+	call	InitializeDeviceParameters
 	jc		SHORT .RecalibrateDrive
-	and		BYTE [di+DPT.bReset], ~FLG_RESET_nINITPRMS
+	and		WORD [di+DPT.wFlags], ~FLG_DPT_RESET_nINITPRMS
 
 	; Recalibrate drive by seeking to cylinder 0
-ALIGN JUMP_ALIGN
 .RecalibrateDrive:
 	call	AH11h_RecalibrateDrive
 	jc		SHORT .InitializeBlockMode
-	and		BYTE [di+DPT.bReset], ~FLG_RESET_nRECALIBRATE
+	and		WORD [di+DPT.wFlags], ~FLG_DPT_RESET_nRECALIBRATE
 
 	; Initialize block mode transfers
 .InitializeBlockMode:
-	call	AH9h_InitializeBlockMode
+	call	InitializeBlockMode
 	jc		SHORT .ReturnNotSuccessfull
-	and		BYTE [di+DPT.bReset], ~FLG_RESET_nSETBLOCK	; Keeps CF clear
+	and		WORD [di+DPT.wFlags], ~FLG_DPT_RESET_nSETBLOCK	; Keeps CF clear
 
 .ReturnNotSuccessfull:
@@ -74,45 +76,8 @@
 
 ;--------------------------------------------------------------------
-; Sends Initialize Device Parameters command to IDE Hard Disk.
-; Initialization is used to initialize logical CHS parameters. Drives
-; may not support all CHS values.
-; This command is only supported by drives that supports CHS addressing.
-;
-; AH9h_InitializeDeviceParameters
+; InitializeDeviceParameters
 ;	Parameters:
-;		DS:DI:	Ptr to DPT
-;	Returns:
-;		AH:		BIOS Error code
-;		CF:		Cleared if succesfull
-;				Set if any error
-;	Corrupts registers:
-;		AL, BX, CX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-AH9h_InitializeDeviceParameters:
-	; No need to initialize CHS parameters if LBA mode enabled
-	test	BYTE [di+DPT.bDrvSel], FLG_IDE_DRVHD_LBA	; Clears CF
-	jnz		SHORT .Return
-
-	push	dx
-	mov		bh, [di+DPT.bPHeads]
-	dec		bh						; Max head number
-	mov		dx, [RAMVARS.wIdeBase]
-	call	HCommand_OutputTranslatedLCHSaddress
-	mov		ah, HCMD_INIT_DEV
-	mov		al, [di+DPT.bPSect]		; Sectors per track
-	call	HCommand_OutputSectorCountAndCommand
-	call	HStatus_WaitBsyDefTime	; Wait until drive ready (DRDY won't be set!)
-	pop		dx
-.Return:
-	ret
-
-
-;--------------------------------------------------------------------
-; Initializes block mode transfers.
-;
-; AH9h_InitializeBlockMode
-;	Parameters:
-;		DS:DI:	Ptr to DPT
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to IDEPACK
 ;	Returns:
 ;		AH:		BIOS Error code
@@ -123,12 +88,36 @@
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-AH9h_InitializeBlockMode:
-	mov		ax, FLG_DRVPARAMS_BLOCKMODE
-	call	AccessDPT_TestIdeVarsFlagsForMasterOrSlaveDrive
-	jz		SHORT .Return				; Block mode disabled (CF cleared)
-	eMOVZX	ax, BYTE [di+DPT.bMaxBlock]	; Load max block size, zero AH
-	test	al, al						; Block mode supported? (clears CF)
-	jz		SHORT .Return				;  If not, return
+InitializeDeviceParameters:
+	; No need to initialize CHS parameters if LBA mode enabled
+	test	BYTE [di+DPT.wFlags], FLG_DRVNHEAD_LBA	; Clear CF
+	jnz		SHORT ReturnSuccessSinceInitializationNotNeeded
+
+	; Initialize Locigal Sectors per Track and Max Head number
+	mov		ah, [di+DPT.bPchsHeads]
+	dec		ah							; Max Head number
+	mov		dl, [di+DPT.bPchsSectors]	; Sectors per Track
+	mov		al, COMMAND_INITIALIZE_DEVICE_PARAMETERS
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_BSY, FLG_STATUS_BSY)
+	jmp		Idepack_StoreNonExtParametersAndIssueCommandFromAL
+
+
+;--------------------------------------------------------------------
+; InitializeBlockMode
+;	Parameters:
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		AH:		BIOS Error code
+;		CF:		Cleared if succesfull
+;				Set if any error
+;	Corrupts registers:
+;		AL, BX, CX, DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+InitializeBlockMode:
+	test	WORD [di+DPT.wFlags], FLG_DPT_BLOCK_MODE_SUPPORTED	; Clear CF
+	jz		SHORT ReturnSuccessSinceInitializationNotNeeded
+
+	mov		al, [di+DPT_ATA.bMaxBlock]	; Load max block size, zero AH
 	jmp		AH24h_SetBlockSize
-.Return:
+ReturnSuccessSinceInitializationNotNeeded:
 	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AHCh_HSeek.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AHCh_HSeek.asm	(revision 149)
+++ trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AHCh_HSeek.asm	(revision 150)
@@ -13,11 +13,11 @@
 ;		DL:		Translated Drive number
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
-;		SS:BP:	Ptr to INTPACK
-;	Parameters on INTPACK in SS:BP:
+;		SS:BP:	Ptr to IDEREGS_AND_INTPACK
+;	Parameters on INTPACK:
 ;		CH:		Cylinder number, bits 7...0
 ;		CL:		Bits 7...6: Cylinder number bits 9 and 8
 ;				Bits 5...0:	Starting sector number (1...63)
 ;		DH:		Starting head number (0...255)
-;	Returns with INTPACK in SS:BP:
+;	Returns with INTPACK:
 ;		AH:		BIOS Error code
 ;		CF:		0 if succesfull, 1 if error
@@ -33,5 +33,4 @@
 %endif
 
-
 ;--------------------------------------------------------------------
 ; AHCh_SeekToCylinder
@@ -42,4 +41,5 @@
 ;		DH:		Starting head number (0...255)
 ;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to IDEREGS_AND_INTPACK
 ;	Returns:
 ;		AH:		BIOS Error code
@@ -49,9 +49,5 @@
 ;--------------------------------------------------------------------
 AHCh_SeekToCylinder:
-	mov		ax, HCMD_SEEK<<8			; Load cmd to AH, AL=zero sector cnt
-	call	HCommand_OutputCountAndLCHSandCommand
-	jc		SHORT .ReturnWithErrorCodeInAH
-	mov		bx, di						; DS:BX now points to DPT
-	jmp		HStatus_WaitIrqOrRdy		; Wait for IRQ or RDY
-.ReturnWithErrorCodeInAH:
-	ret
+	mov		ah, COMMAND_SEEK
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_DRQ, FLG_STATUS_DRDY)
+	jmp		Idepack_TranslateOldInt13hAddressAndIssueCommandFromAH
